FUNCTION ShowExcelTable(pcXLS, plColor, plSuppressBlank)
private all like x*
IF glRunExcel
	plColor=iif(PCount() < 2, .F., plColor)
	plSuppressBlank=iif(PCount() < 3, .F., plSuppressBlank)
	xoExcel=NewObject("Excel.Application")
  WITH xoExcel
  .workbooks.open(FullPath(pcXLS))
	If plColor
	  .Cells(2,1).Select()
	  .Selection.Interior.ColorIndex = 37	&& bledemodra
		ObarviExcelTable(@xoExcel, 1, 2, 1)
	EndIf
	If plSuppressBlank
		SuppressBlankInExcelTable(@xoExcel, 2, 1, 0, 1)
	EndIf
  xnLastCol=.ActiveCell.SpecialCells(11).Column		&& 1. radek Bold a zluty
  xnLastRow=.ActiveCell.SpecialCells(11).Row
  .Range(.Cells(1,1), .Cells(1,xnLastCol)).Select()
  .Selection.Font.Bold=.T.
  .Selection.Interior.ColorIndex = 6
  .Cells.Select()					&& upravit sirku sloupcu
  .Selection.Autofilter()
  .Selection.Columns.AutoFit()
  .Cells(xnLastRow+1, 1).Value=[<<< Konec prehledu >>>]
  .Range(.Cells(xnLastRow+1,1), .Cells(xnLastRow+1,xnLastCol)).Select()
  .Selection.Font.Bold=.T.
  .Selection.Interior.ColorIndex = 6
  .Cells(2,1).Select()
  .ActiveWindow.SplitColumn=0
  .ActiveWindow.SplitRow=1
  .ActiveWindow.FreezePanes=.T.
  .visible=.T.
  ENDWITH
ENDIF  
RETURN .T.

**********

FUNCTION	ObarviExcelTable(poExcel, pnPivotCol, pnRowVon, pnColumnVon, pnRowBis, pnColumnBis, ;	
					pnLen, plUpperCase)
*	obarvit stejne radky (podle pivot sloupce)
*	obarveni vsech zadanych sloupcu
*	tabulka musi uz byt otevrena a selected
private all like x*

WITH poExcel

xnRowF=iif(empty(pnRowVon), 1, pnRowVon)
xnColF=iif(empty(pnColumnVon), 1, pnColumnVon)
xnRowL=iif(empty(pnRowBis), .ActiveCell.SpecialCells(11).Row, pnRowBis)
xnColL=iif(empty(pnColumnBis), .ActiveCell.SpecialCells(11).Column, pnColumnBis)

xnPivotCol=iif(empty(pnPivotCol), xnColF, pnPivotCol)

xnLen=iif(empty(pnLen), 255, pnLen)
plUpperCase=iif(empty(plUppercase), .F., plUpperCase)

Dimension xaCI[2, 2]
store -999 to xaCI		&& init. hodnoty
xxVV=Transform(.Cells(xnRowF, xnPivotCol).Value)		&& pocatecni hodnoty podle 1. pole
xxVV=iif(plUpperCase, xxVV, Upper(xxVV) )
xaCI[1, 1]=.Cells(xnRowF, xnPivotCol).interior.ColorIndex
xaCI[1, 2]=.Cells(xnRowF, xnPivotCol).Font.ColorIndex
xnPendel=1
FOR xnR=xnRowF to xnRowL
		xxCell=Transform(.Cells(xnR, xnPivotCol).Value)
		xxCell=iif(plUpperCase, xxCell, Upper(xxCell) )
		xnII=.Cells(xnR, xnPivotCol).interior.ColorIndex
		xnFI=.Cells(xnR, xnPivotCol).Font.ColorIndex
		.Range(.Cells(xnR, xnColF), .Cells(xnR, xnColL)).Select()

		If left(xxCell, xnLen)==left(xxVV, xnLen)
        .selection.interior.ColorIndex=xaCI[xnPendel, 1]
        .selection.Font.ColorIndex=xaCI[xnPendel, 2]
    Else
      xnPendel=iif(xnPendel=1, 2, 1)
      if xaCI[xnPendel, 1]=-999
        xaCI[xnPendel, 1]=xnII
        xaCI[xnPendel, 2]=xnFI
      endif
      xxVV=xxCell
      if xaCI[xnPendel]#-999
        .selection.interior.ColorIndex=xaCI[xnPendel, 1]
        .selection.Font.ColorIndex=xaCI[xnPendel, 2]
      endif
    Endif

ENDFOR
ENDWITH	&& poExcel
RETURN .T.

*****

FUNCTION SuppressBlankInExcelTable(poExcel, pnRowVon, pnColumnVon, pnRowBis, pnColumnBis, ;	
					pnLen, plUpperCase)
*	odstranit opakujici se hodnoty
*	tabulka musi uz byt otevrena a selected
private all like x*
xnRowF=iif(empty(pnRowVon), 1, pnRowVon)
xnColF=iif(empty(pnColumnVon), 1, pnColumnVon)
xnRowL=iif(empty(pnRowBis), .ActiveCell.SpecialCells(11).Row, pnRowBis)
xnColL=iif(empty(pnColumnBis), .ActiveCell.SpecialCells(11).Column, pnColumnBis)
xnLen=iif(empty(pnLen), 255, pnLen)
plUpperCase=iif(empty(plUppercase), .F., plUpperCase)
Dimension xaCI[2]

WITH poExcel
FOR xnC=xnColF to xnColL
  store chr(255) to xxVV
  xnPendel=1
  For xnR=xnRowF to xnRowL
    xxCell=Transform(.Cells(xnR, xnC).Value)
    xxCell=iif(plUpperCase, xxCell, Upper(xxCell) )
    
    If left(xxCell, xnLen)==left(xxVV, xnLen)
        .Cells(xnR, xnC).Value=.NULL.
    Else
      xxVV=xxCell
    Endif

  EndFor
ENDFOR
ENDWITH	&& poExcel
RETURN .T.
